#!/usr/bin/bash
set -eu

share="/srv/samba/schools/default-school/share/"
home="$(getent passwd "$SUDO_UID" | cut -d : -f 6 | sed 's|/srv/samba/schools/default-school/||')"

exit_script() {
    echo "unmounting media - terminated by trap!" >> "/tmp/${SUDO_UID}-exit-mount.log"
    findmnt "/media/${SUDO_USER}/oldhome" && umount "/media/${SUDO_USER}/oldhome" && rmdir "/media/${SUDO_USER}/oldhome"
    findmnt "/media/${SUDO_USER}/linuxhome" && umount "/media/${SUDO_USER}/linuxhome" && rmdir "/media/${SUDO_USER}/linuxhome"
    trap - SIGHUP SIGINT SIGTERM # clear the trap
    kill -- -$$ # Sends SIGTERM to child/sub processes
}

if [[ "$#" -gt 0 ]] && [[ "$1" = '-u' ]]; then
    findmnt "/media/${SUDO_USER}/home"    && umount "/media/${SUDO_USER}/home"    && rmdir "/media/${SUDO_USER}/home"
    #findmnt "/media/${SUDO_USER}/share"   && umount "/media/${SUDO_USER}/share"   && rmdir "/media/${SUDO_USER}/share"
    findmnt "/media/${SUDO_USER}/oldhome" && umount "/media/${SUDO_USER}/oldhome" && rmdir "/media/${SUDO_USER}/oldhome"
    findmnt "/media/${SUDO_USER}/linuxhome" && umount "/media/${SUDO_USER}/linuxhome" && rmdir "/media/${SUDO_USER}/linuxhome"
elif [ "$#" -gt 0 ] && [ "$1" = '-o' ]; then
    echo "Einbinden der Daten des alten/bisherigen Systems (PaedML Novell)."
    echo "Bitte den Username und Passwort aus dem ALTEN System eingeben."
    read -rp "Username: " username
    read -srp "Passwort: " PASSWD
    export PASSWD
    echo
    mkdir -p "/media/${SUDO_USER}/oldhome"
    #errcode=$(mount -t cifs -o "username=${username},uid=${SUDO_UID},gid=1010,file_mode=0770,dir_mode=0770,forceuid,forcegid" \
    #	    "//192.168.1.2/DOCS/fvs" "/media/${SUDO_USER}/oldhome")
    #if [[ ! "${errcode}" ]]; then
    mount -t cifs -o "username=${username},uid=${SUDO_UID},gid=1010,file_mode=0770,dir_mode=0770,forceuid,forcegid" \
	    "//192.168.1.2/DOCS/fvs" "/media/${SUDO_USER}/oldhome"
    #echo "Mounting successfull!"
    echo "Einbindung erfolgreich!"
    echo "Dieses Fenster bitte nicht schließen!"
    #echo "Um weiter zu arbeiten: <Strg> + <Z>"
    trap exit_script SIGHUP SIGINT SIGTERM
    sleep infinity 
elif [ "$#" -gt 0 ] && [ "$1" = '-l' ]; then
    echo "Einbinden des Netboot-Home-Verzeichnises. Daten des alten/bisherigen Systems (PaedML Novell)."
    echo "Bitte den Username und Passwort aus dem ALTEN System (PaedML Novell) eingeben."
    echo "Bitte auch Groß- und Kleinschreibung achten."
    read -rp "Username: " username
    mkdir -p "/media/${SUDO_USER}/linuxhome"
    mount -t fuse -o "allow_other,uid=${SUDO_UID},gid=1010,reconnect" \
          "sshfs#${username}@home.steinbeisschule-reutlingen.de:" "/media/${SUDO_USER}/linuxhome"
    #echo "Mounting successfull!"
    echo "Einbindung erfolgreich!"
    echo "Dieses Fenster bitte nicht schließen!"
    #echo "Um weiter zu arbeiten: <Strg> + <Z>"
    trap exit_script SIGHUP SIGINT SIGTERM
    sleep infinity 
else
    #mkdir -p "/media/${SUDO_USER}"
    #chown "${SUDO_USER}:1010" "/media/${SUDO_USER}"
    chgrp 1010 "/lmn/media/${SUDO_USER}"
    chmod 0770 "/lmn/media/${SUDO_USER}"
    if ! findmnt "/lmn/media/${SUDO_USER}/share"; then
      [[ -d "/lmn/media/${SUDO_USER}/share" ]] || mkdir "/lmn/media/${SUDO_USER}/share"
      mount --bind "/lmn/media/${SUDO_USER}/.default-school/share" "/lmn/media/${SUDO_USER}/share"
    fi
    if ! findmnt "/lmn/media/${SUDO_USER}/home"; then
      [[ -d "/lmn/media/${SUDO_USER}/home" ]] || mkdir "/lmn/media/${SUDO_USER}/home"
      home="$(getent passwd $SUDO_USER | cut -d: -f6)"
      mount --bind "/lmn/media/${SUDO_USER}/.default-school/${home##/srv/samba/schools/default-school/}" "/lmn/media/${SUDO_USER}/home"
    fi
    #mkdir -p "/media/${SUDO_USER}/home"
    #mkdir -p "/media/${SUDO_USER}/share"
    #mount -t cifs -o "sec=krb5i,cruid=${SUDO_UID},user=${SUDO_USER},uid=${SUDO_UID},gid=1010,file_mode=0770,dir_mode=0770,mfsymlinks" \
    #       "//server/default-school/${home}" "/media/${SUDO_USER}/home"
    #mount -t cifs -o "sec=krb5i,cruid=${SUDO_UID},user=${SUDO_USER},uid=${SUDO_UID},gid=1010,file_mode=0770,dir_mode=0770,mfsymlinks" \
    #       "//server/default-school/share" "/media/${SUDO_USER}/share"
fi
